# -*- coding: utf-8 -*-

__module_name__ = "Bienvenue"
__module_version__ = "0.42"
__module_description__ = "Souhaite la bienvenue"
__module_author__ = "ephem <ephem AT deepumbra DOT net>"

import xchat

my_nick = xchat.get_info('nick')
chans = []
switches = []
notified = []
pref_hook = None

def loadprefs(userdata):
    global chans
    global switches
    xchat.unhook(pref_hook)
    try: prefs = open("Plugins/Bvn42.txt", 'r')
    except: return init("#all")
    for ligne in prefs.readlines():
        tabs = ligne.strip("\r\n").split(" $switch ")
        chans.append(tabs[0])
        switches.append(tabs[1])
    prefs.close()
    ## print "prefs Bienvenue chargées"
    init("#all")

def saveprefs(userdata):
    try: prefs = open("Plugins/Bvn42.txt", 'r')
    except: prefs = None
    tabs = []
    if prefs != None:
        for ligne in prefs.readlines(): tabs.extend(ligne.strip("\r\n").split(" $switch ")) # on lit les canaux déjà présents dans les prefs
        prefs.close()
    i = 0
    while i < len(chans):
        if chans[i] in tabs and switches[i] != tabs[2*i+1]: tabs[2*i+1] = switches[i] # si le mode a changé, on le rectifie
        elif chans[i] not in tabs: tabs.extend([chans[i], switches[i]]) # on rajoute les canaux qui ne sont pas dans les prefs
        i += 1
    prefs = open("Plugins/Bvn42.txt", 'w')
    i = 0
    while i < len(tabs): 
        prefs.write(tabs[i] + " $switch " + tabs[i+1] + "\n") # séparateur "$switch" en cas d'espaces dans les noms des serveurs
        i += 2
    prefs.close()
xchat.hook_unload(saveprefs)

def init(canal):
    global chans
    global switches
    list = xchat.get_list("channels")
    if canal == "#all":
        for chan in list:
            ct = xchat.find_context(channel=chan.channel)
            if ct != None: canal = channel_id(ct)
            if canal not in chans:
                chans.append(canal)
                switches.append("off")
    elif canal not in chans:
        chans.append(canal)
        switches.append("off")
    ## print "Bienvenue initialisé"

def channel_id(ct):
    return (ct.get_info("network") or ct.get_info("server")) + "@" + ct.get_info("channel")

def on_join(word, word_eol, userdata):
    ct = xchat.get_context()
    chan = channel_id(ct)
    if chan not in chans: init(chan)
    p = chans.index(chan)
    nick = word[0].lower()
    if switches[p] == "on" and nick not in notified:
        xchat.command("notice %s %s te souhaite la bienvenue sur le canal %s, %s" % (nick, my_nick, chan, nick))
        ##  Ajout pour les événements spéciaux, par exemple le 1er Mai


        ##  xchat.command("say Aujourd'hui 1er Mai %s t'offre un brin de muguet %s :) " % (my_nick, nick))
        notified.append(nick)
    return xchat.EAT_NONE

xchat.hook_print('Join', on_join)


def about(word, word_eol, userdata):
    i = 0
    servprompt = {}
    while i < len(chans):
        if servprompt.has_key(chans[i].split('@')[0]): servprompt[chans[i].split('@')[0]] += "| " + chans[i].split('@')[1]  + " : " + switches[i] + " |"
        else: servprompt[chans[i].split('@')[0]] = "| " + chans[i].split('@')[1]  + " : " + switches[i] + " |"
        i += 1
    for serv in servprompt: print "sur " + serv + " : " + servprompt[serv]
    print "Module Bienvenue 0.42 par ephem"
    print "/ON (/OFF) Bienvenue [all] pour (des)activer sur le canal, option \"all\" pour tous les canaux"
    return xchat.EAT_ALL

xchat.hook_command("ABOUT",about)

def onoff(word, word_eol, userdata):
    ct = xchat.get_context()
    chan = channel_id(ct)
    if chan not in chans: init(chan)
    cmd = word[0].lower()
    l = len(word)
    option = 0
    sep = ""
    if cmd == "off": sep = "dés"
    if l > 2: option = word[2].lower()
    if l == 1: print "usage: on/off bienvenue [all]"
    elif word[1].lower() in ("slt", "bienvenue"):
        if option == "all":
            for canal in chans: switches[chans.index(canal)] = cmd
            print "module Bienvenue %sactivé sur tous les canaux" % sep
        else:
            switches[chans.index(chan)] = cmd
            print "module Bienvenue %sactivé sur %s" % (sep, chan)
    saveprefs(None)
    return xchat.EAT_ALL

xchat.hook_command("ON",onoff,help="usage: /ON bienvenue [all]")
xchat.hook_command("OFF",onoff,help="usage: /OFF bienvenue [all]")

pref_hook = xchat.hook_timer(17640,loadprefs)
print __module_name__, __module_version__, "loaded"
